Subject: Re: bug#25881: guix package --remove $PKG downloads and updates other packages

From: [email-masked] (Ludovic Courtès)
Date: Wed, 08 Mar 2017 09:56:46 +0100

<[email-masked]> skribis:

> Recently I had to remove duplicity from a profile because it doesn't
> support hardlinks, and something very interesting happened:
>
>
> === start of output ===
> guix package --remove duplicity
> The following package will be removed:
>    duplicity
> 0.7.11	/gnu/store/3a9ggca9cw4gv69lg8ihi1c6jx2xd92j-duplicity-0.7.11
>
> substitute: warning: 'https_proxy' is ignored
> updating list of substitutes from 'https://mirror.hydra.gnu.org'...
> 100.0%g'...  95.2% The following derivations will be built:
>    /gnu/store/s8a6rx3qrgpbw3mrllp2zmijxkrzzgh6-profile.drv
>    /gnu/store/46qgf7ws2rcz260sxhxf4bh5a7a3n5ks-mkfontscale-1.1.2.drv
>    /gnu/store/3j49ffh3v8dd9al122jfb5kvghrzjlds-module-import.drv
>    /gnu/store/4ff02yd8i72pfw5nki15v51abdsnn9vw-module-import-compiled.drv
>    /gnu/store/p20nk4l00zywxwbl5fkdrha5ajwc9lw2-mkfontscale-1.1.2.drv
>    /gnu/store/z3dq9p2hrv3ihckx3b10hambla1advqq-mkfontdir-1.0.7.drv
>    /gnu/store/n4ypy18jmpwpmc591pf80cy6aiw8igsn-fonts-dir.drv
>    /gnu/store/a5f32zly8isws5n8jnnrqz97acf0z0qv-texinfo-6.3.drv
>    /gnu/store/mlyxjdnwna57v4y38955p3wj67lihn7p-info-dir.drv
>    /gnu/store/25l9jdfj56yb8na0wb1khixg1zwq94f2-module-import.drv
>    /gnu/store/b7lrgb3dzy9d6l41ya7cy8vnf674qr6y-module-import-compiled.drv
>    /gnu/store/275lpklrjq74dwbzlafnlb8rd2xdqvnq-ca-certificate-bundle.drv
>    /gnu/store/3jggaks2xcmk72ykgqkl703i07mm3f4s-module-import-compiled.drv
>    /gnu/store/5kafw17sff053kk4a80ynvza3vlf2ack-guile-2.0.12.drv
>    /gnu/store/hknlvn5319g9pinz6f3r59qjp4b9399g-module-import.drv
> The following files will be downloaded:
>    /gnu/store/i7228ph97vqbpw8v4m0xmfgnppy149vq-mkfontscale-1.1.2
>    /gnu/store/7cvdqkddzbcan5jxwyvsmar0h7wlckik-module-import-compiled
>    /gnu/store/sq03gq3lhpwgbiy9k5klnqd2q8z7iwxp-module-import
>    /gnu/store/8l77r5ikky0ghm1w9zc2pxfn80rb5n5w-mkfontdir-1.0.7
>    /gnu/store/j6k8xgsqrl5v1ajqh3i1wb603rzzg1jg-texinfo-6.3
>    /gnu/store/dn9f03l4zh3y35632sv1zppydbag3n17-libfontenc-1.1.3

As surprising as it may seem, this is expected: to build a profile, you
need Guile and a couple of other packages (such as Texinfo, to build the
‘dir’ file), which is why extra things are being downloaded/built.

I agree this is confusing, especially the way the UI shows it.  But it’s
an important feature.

> If this is the intended behavior, then I think some thoughts on whether
> or not this violates the user's right to choose when and how they update
> their system is needed.

IMO this doesn’t violate the user’s right to choose when they update
their system because it doesn’t update their system.

Thoughts?

Ludo’.